// ** AUTO-UI IMPORT STATEMENTS **
// ** END AUTO-UI IMPORT STATEMENTS **



import hr.skolskaknjiga.wordshuffle.*;

class hr.skolskaknjiga.wordshuffle.Sentence extends MovieClip {

	public static var CLASS_REF = hr.skolskaknjiga.wordshuffle.Sentence;
	public static var LINKAGE_ID:String = "Sentence";

	///private var EB:EventBroadcaster;
	
	public var index:Number;
	public var correctIndicator:MovieClip;
	
	private var dragged:Word;
	
	private var origSentence:String;
	private var currentSentence:String;
	private var origTFormat:TextFormat;
	
	private var draggedPos:Object;
	
	private var words:Array;
	private var wordMCs:Array;
	
	private var options:Object;
	

// ** AUTO-UI ELEMENTS **
// ** END AUTO-UI ELEMENTS **

	//////////////////////////////
	//////// CONSTRUCTOR /////////
	//////////////////////////////
	public function Sentence() {
		///EB = EventBroadcaster.getInstance();
		words = new Array();
		wordMCs = new Array();
		draggedPos = new Object();
		options = _global.shuffleMain.options;
		
	}
	private function onLoad() {
	}

	//////////////////////////////
	/////////// PUBLIC ///////////
	//////////////////////////////
	public function generateWords(stc:TextField):Void {
		origSentence = stc.text;
		origTFormat = stc.getTextFormat();
		words = stc.text.split(" ");
		correctIndicator = this.attachMovie("correctIndicator", "correctIndicator", this.getNextHighestDepth());
		correctIndicator._x = -this._x + options.correct_indicator_position;
	}

	public function startChecking(mc:Word):Void {
		dragged = mc;
		draggedPos._x = mc._x;
		draggedPos._width = mc._width;
		this.onEnterFrame = checkPositions;
	}
	
	public function get correct():Boolean {
		if (currentSentence == origSentence) return true;
		return false;
	}
	
	public function showCorrect():Void {
		correctIndicator.gotoAndStop("tocno");
	}
	public function showWrong():Void {
		correctIndicator.gotoAndStop("netocno");
	}

	//////////////////////////////
	/////////// PRIVATE //////////
	//////////////////////////////
	
	private function checkPositions() {
		wordMCs.sort(comparePosition);
		currentSentence = "";
		positionWords();
		
		///if (currentSentence == origSentence) trace("RIGHT!!!");
	}

	private function stopChecking() {
		this.onEnterFrame = null;
		dragged._x = draggedPos._x;
		if (currentSentence == origSentence) _global.shuffleMain.solved(this);
	}
	
	private function positionWords():Void {
		for (var i=0; i<wordMCs.length; i++) {
			var w:Word = wordMCs[i];
			var preW =  wordMCs[i-1];
			if (preW == dragged) preW = draggedPos;
			var space:String = (i == wordMCs.length - 1)? "" : " ";
			currentSentence += w.text + space;
			var px = (i == 0)? 0 : preW._x;
			var pw = (i == 0)? 0 : preW._width;
			var marg = (i == 0)? 0 : options.word_distance;
			if (w.relativeSize > 1.2) marg *= Math.ceil(w.relativeSize);
			if (w != dragged) {
				w._x = px + pw + marg;
			}
			else {
				draggedPos._x = px + pw + marg;
			}
		}
		
	}
	
	private function comparePosition (element1, element2):Number{
		var x1:Number = element1._x + (element1._width / 2);
		var x2:Number = element2._x + (element2._width / 2);
		if (x1 < x2) {
			return -1;
		}else if (x1 > x2) {
			return 1;
		}else{
			return 0;
		}
	}
	
	private function getWordByText(txt:String):Word {
		var found:Word = null;
		for (var i:Number = 0; i < wordMCs.length; i++) {
			var w:Word = wordMCs[i];
			if (w.text == txt) {
				found = w;
				break;
			}
		}
		return found;
	}
	
	private function cloneArray(arr1:Array):Array {
		var arr2:Array = new Array();
		for (var i:Number = 0; i < arr1.length; i++) {
			var val = arr1[i];
			arr2.push(val);
		}
		return arr2;
	}

}


